# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test_56
# FileName:      db.py
# Author:       xxxxxxx
# Datetime:     2023/8/4 14:21
# Description:
# 
# ---------------------------------------------------------------------------
import pymysql
from APIAutoTest02.common.read_ini import ReadIni


class DB:
    def __init__(self):
        """链接数据库，获取链接对象，再获取游标对象"""
        read_ini = ReadIni()
        # 使用pymysql里面的connect类链接数据库,获取链接对象
        self.conn = pymysql.connect(
                        host=read_ini.get_sql_connect_message("host"),
                        port=int(read_ini.get_sql_connect_message("port")),
                        user=read_ini.get_sql_connect_message('user'),
                        password=read_ini.get_sql_connect_message("pwd"),
                        database=read_ini.get_sql_connect_message("database"),
                        charset="utf8")
        # 使用链接对象，创建游标对象
        self.cursor = self.conn.cursor()

    def close(self):
        # 先关闭游标对象
        self.cursor.close()
        # 再关闭链接对象
        self.conn.close()

    def delete(self, sql_sentence):
        """
        执行删除的sql语句
        :param sql_sentence: sql语句
        :return: None
        """
        # 使用游标对象的execute方法执行sql语句
        self.cursor.execute(sql_sentence)
        # 使用链接对象提交
        self.conn.commit()

    def select(self, sql_sentence):
        """
        执行查询的sql语句
        :param sql_sentence: sql语句
        :return: 查询的结果
        """
        # 使用游标对象的execute方法执行sql语句
        self.cursor.execute(sql_sentence)
        # 使用游标对象的fetchall方法获取查询的结果
        select_result = self.cursor.fetchall()
        # 判断查询的结果是否为空的元组，如果是空的元组返回None，如果不是空的元组返回查询结果的值
        if select_result:
            return select_result[0][0]


if __name__ == '__main__':
    db = DB()
    sql = """SELECT ID_ FROM uc_demension WHERE `CODE_`="test56_dem";"""
    print(db.select(sql))