# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test_56
# FileName:      requests_method.py
# Author:       xxxxxxx
# Datetime:     2023/8/4 15:42
# Description:
# 
# ---------------------------------------------------------------------------
import base64
import requests
from APIAutoTest02.common.read_ini import ReadIni


class RequestsMethod:
    def __init__(self):
        """
        关联登录成功的状态，关联token
        """
        url = ReadIni().get_host("test_bpm") + "/auth"
        data = {"username": "admin", "password": base64.b64encode("123456".encode("utf-8")).decode("utf-8")}
        self.bpm_session = requests.sessions.Session()
        # 发送请求，获取token，将token更新到Session对象的headers
        self.bpm_session.headers["Authorization"] = "Bearer " + self.bpm_session.post(url=url, json=data).json().get("token")

    def request_all(self, method, url, mime, case_data):
        """
        根据不同的媒体类型，使用不同的关键字传参
        :param method: 请求方法
        :param url: url
        :param mime: 媒体类型
        :param case_data: 用例数据
        :return: Response type
        """
        if mime == "application/x-www-form-urlencoded" or mime == "x-www-form-urlencoded":
            return self.bpm_session.request(method=method, url=url, data=case_data)

        elif mime == "application/json" or mime == "json":
            return self.bpm_session.request(method=method, url=url, json=case_data)

        elif mime == "multipart/form-data" or mime == "form-data":
            return self.bpm_session.request(method=method, url=url, files=case_data)

        elif mime == "query" or mime == "params":
            return self.bpm_session.request(method=method, url=url, params=case_data)


        elif mime == "text/plain" or mime == "text":
            return self.bpm_session.request(method=method, url=url, data=case_data)

        elif mime == "application/Json|query" or mime == "json|query" or "json|params":
            return self.bpm_session.request(method=method, url=url, params=case_data["query"], json=case_data["body"])

        elif mime is None:
            return self.bpm_session.request(method=method, url=url)

        else:
            raise NameError("媒体类型的值错误")


if __name__ == '__main__':
    req = RequestsMethod()
